//-----------------------------------------------------------------------------
// INTERNAL.H
// By Dean Harding
// 
// Copyright (c) 2000/2001 Dean Harding
//-----------------------------------------------------------------------------
#pragma once

//-----------------------------------------------------------------------------
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#ifdef _DEBUG
#define ASSERT(x)		assert(x)
#else
#define ASSERT(x)		(x)
#endif

//-----------------------------------------------------------------------------
#include "logger.h"
#include "item.h"
#include "queue.h"

//-----------------------------------------------------------------------------
// worker thread that does all the actual logging work.  See worker.cpp for
// it's implementation.
DWORD WINAPI LoggerWorkerThread( void *pData );

//-----------------------------------------------------------------------------
// This is the main queue that all the loggers add to and the worker thread
// reads from.  I know, I know, it's a global variable - so kill me!
extern CQueue<CLoggerItem>g_LoggerQueue;

//-----------------------------------------------------------------------------
// this is the class that actually implements the functionality of CLogger.
// see loggerimpl.cpp for it's implementation.
class CLoggerImpl : public CLogger
{
protected:
	// current format, as set by SetFormat()
	DWORD m_dwFormat;

	// current process name, as set by SetName()
	TCHAR *m_szProcName;

	// current log file name, as set by SetLogFile()
	TCHAR *m_szLogFile;
public:
	CLoggerImpl( TCHAR *szLogFile );
	~CLoggerImpl();

	void Release();

	void SetFormat( DWORD dwFormat );
	DWORD GetFormat();

	void SetName( TCHAR *szName );
	TCHAR *GetName();

	void Print( TCHAR *szFormat, ... );
};

//-----------------------------------------------------------------------------
// End of INTERNAL.H
//-----------------------------------------------------------------------------
